<template>
  <nuxt-link @click="toggleSidebar" :to="menu?.TabURL" class="w-full">
    <div class="flex flex-row items-center gap-2.5 py-2.5">
      <svg-icon
        :svgName="`icon-${menu?.TabType.toLowerCase().replaceAll(' ', '-')}`"
        class="icon w-[24px] h-[24px]"
      />
      <span
        class="uppercase"
        :class="
          checkActiveTab(activetab, menu) ? 'menu-active' : 'sidebar-text'
        "
      >
        {{ $t(menu?.TabType.replace(" ", "_").toLowerCase()) }}
      </span>
    </div>
  </nuxt-link>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import { useRoute } from "vue-router";
import { TabInfo } from "@/models/IGetPlayableGamesResponse";
import { store } from "@/store";

export default defineComponent({
  props: {
    menu: {
      require: true,
      type: Object as PropType<TabInfo>,
    },
  },
  setup() {
    const toggleSidebar = () => {
      store.commit("updateSidebar", !store.state.showSidebar);
    };
    const { getAssetImage } = commonHelper;
    const handleImageRender = (img: string) => {
      let src = "";
      try {
        src = getAssetImage(
          `assets/theme/new_black_theme/sidebar/${img.replace(" ", "")}.svg`
        );
      } catch (_) {
        src = "";
      }
      return src;
    };
    const route = useRoute();
    const activetab = computed(() => route.path.slice(1));
    const checkActiveTab = (active: string, menu: TabInfo) => {
      if (route.matched[0].name === "GameInitial") {
        return active
          .replace(" ", "")
          .replace("-", "")
          .toLowerCase()
          .includes(menu?.TabType.replace(" ", "").toLowerCase());
      }
      if (route.matched[0].name !== "GameInitial") {
        return (
          active.replace(" ", "").replace("-", "").toLowerCase() ===
          menu?.TabType.replace(" ", "").toLowerCase()
        );
      }
      return false;
    };
    return {
      toggleSidebar,
      handleImageRender,
      activetab,
      checkActiveTab,
    };
  },
});
</script>

<style lang="scss">
.menu-active {
  color: var(--selected);
}
</style>
<style lang="scss" scoped>
.router-link-active {
  .icon-angle-right {
    color: var(--selected);
  }
}
</style>
